/****************************************************************************\
*                                                                            *
* New World IV Source Copyright (c) James Ferry 2001                         *
* NWIV site - http://www.dukeworld.com/nw4/nwiv                              *
*                                                                            *
* "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman               *
* Ken Silverman's official web site: "http://www.advsys.net/ken"             *
* See the included license file "BUILDLIC.TXT" for license info.             *
* This file has been modified from Ken Silverman's original release          *
*                                                                            *
*                                                                            *
* Release 1                                                                  *
* The enemy AI is a bit dodgey.  The movement code is still the same as the  *
* original build engine (ie I haven't put my version in yet), so if a        *
* monster walks down a wall it will crash.                                   *
* I haven't commented anything in this thing, it is just as I use it.        *
*                                                                            *
* FILE.C                                                                     *
* used in the sound editor                                                   *
*                                                                            *
\****************************************************************************/

#include<dos.h>
#include<stdio.h>
#include<malloc.h>
extern long SND_VOLUME;

   //MUST CALL MALLOC THIS WAY TO FORCE CALLS TO KMALLOC!
void *kmalloc(size_t size) { return(malloc(size)); }
void *kkmalloc(size_t size);
#pragma aux kkmalloc =\
	"call kmalloc",\
	parm [eax]\

	//MUST CALL FREE THIS WAY TO FORCE CALLS TO KFREE!
void kfree(void *buffer) { free(buffer); }
void kkfree(void *buffer);
#pragma aux kkfree =\
	"call kfree",\
	parm [eax]\


#define MAXWAVES 1024
extern char *snd;
char nwd[1024];
char runonce;
extern long numwaves;
extern char instname[MAXWAVES][16];
//extern long wavinfo[MAXWAVES][16];
extern long wavleng[MAXWAVES];
extern long repstart[MAXWAVES], repleng[MAXWAVES];
extern long finetune[MAXWAVES];

	//Other useful wave variables
extern long totsndbytes, totsndmem, wavoffs[MAXWAVES];


extern long splc[16];
extern volatile char keystatus[256];
extern short instnum;
extern short viewinst;
typedef struct _wavheader
{
char RIFF[4];
long a;
char WAVEfmt[8];
long b1;
short frmt;
unsigned short chan;
unsigned long b3;
unsigned long b4;
unsigned short d1;
unsigned short d2;
char data[4];
long c;
}WAVHEADER;
extern WAVHEADER wavheader[MAXWAVES];


#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

 int curfile;
 int viewfile;
 int files;
 char filetypes[MAXWAVES];
 char fileuse[MAXWAVES];
 char filenames[MAXWAVES][17];
 long filesizes[MAXWAVES];

loadfile(long num)
{
 struct find_t fileinfo;
 char string[80];
 char string1[80];
 char string2[80];
 char string3[80];
 FILE *in;
 int b,i;
  i=curfile;
   memcpy(string1,wavheader[i].RIFF,4);string1[4]=0;
   memcpy(string2,wavheader[i].WAVEfmt,8);string2[8]=0;
   memcpy(string3,wavheader[i].data,4);string3[4]=0;
   if(strcmp("WAVEfmt ",string2)==0&&strcmp("data",string3)==0&&strcmp("RIFF",string1)==0)
    if(
     (wavheader[i].chan==1||wavheader[i].chan==2)&&
     (wavheader[i].d2==8||wavheader[i].d2==16)&&
     strcmp("WAVEfmt ",string2)==0&&strcmp("data",string3)==0&&
     filesizes[i]>=wavheader[i].c+44
    )
    addwave(num);
}



displayfile()
{
 struct find_t fileinfo;
 char filestring[1024];
 char string[80];
 char string1[80];
 char string2[80];
 char string3[80];
 FILE *in;
 int b,i;
 b=files-viewfile>25?viewfile+25:files;
 for(i=viewfile;i<b;i++)
  if(filetypes[i]==1&&fileuse[i]==3)
  {
   sprintf(filestring,"%s",filenames[i]);
   fileuse[i]=0;
   if(filesizes[i]>=44&&(in=fopen(filestring,"rb"))!=NULL)
   {
    fread(&wavheader[i],1,44,in);
    fclose(in);
    fileuse[i]=0;
    memcpy(string1,wavheader[i].RIFF,4);string1[4]=0;
    memcpy(string2,wavheader[i].WAVEfmt,8);string2[8]=0;
    memcpy(string3,wavheader[i].data,4);string3[4]=0;
    if(strcmp("WAVEfmt ",string2)==0&&strcmp("data",string3)==0&&strcmp("RIFF",string1)==0)
     if((wavheader[i].chan==1||wavheader[i].chan==2)&&
      (wavheader[i].d2==8||wavheader[i].d2==16)&&
      strcmp("WAVEfmt ",string2)==0&&strcmp("data",string3)==0&&
      filesizes[i]>=wavheader[i].c+44
     )
     fileuse[i]=1;
   }
  }



 for(i=viewfile;i<b;i++)
 {
   memcpy(string1,wavheader[i].RIFF,4);string1[4]=0;
   memcpy(string2,wavheader[i].WAVEfmt,8);string2[8]=0;
   memcpy(string3,wavheader[i].data,4);string3[4]=0;
   if(fileuse[i]==1&&strcmp("WAVEfmt ",string2)==0&&strcmp("data",string3)==0&&strcmp("RIFF",string1)==0)
    sprintf(string,"%s   %s   %i hz",
     wavheader[i].chan==1?"MONO  ":"STEREO",
     wavheader[i].d2==8?"8 bits ":"16 bits",
     wavheader[i].b3);
   else
    sprintf(string,"");

  if(i==curfile)
  {
   if(fileuse[i]==0)
   {
    print(0,i-viewfile,"                                                                                ",filetypes[i]==2?9:7,4);
    print(0,i-viewfile,filenames[i],filetypes[i]==2?9:7,4);
    print(20,i-viewfile,string,filetypes[i]==2?9:7,4);
   }
   else
   {
    print(0,i-viewfile,"                                                                                ",15,4);
    print(0,i-viewfile,filenames[i],15,4);
    print(20,i-viewfile,string,15,4);
   }
  }
  else
   if(fileuse[i]==0)
   {
    print(0,i-viewfile,"                                                                                ",filetypes[i]==2?9:7,0);
    print(0,i-viewfile,filenames[i],filetypes[i]==2?9:7,0);
    print(20,i-viewfile,string,filetypes[i]==2?9:7,0);
   }
   else
   {
    print(0,i-viewfile,"                                                                                ",15,0);
    print(0,i-viewfile,filenames[i],15,0);
    print(20,i-viewfile,string,15,0);
   }
 }
}


filehandle()
{
 struct find_t fileinfo;
 char string1[80];
 char string2[80];
 char string3[80];
 char filestring[1024];
 char wildcard[1024];
 FILE *in;
 int i;

 runonce=1;

 while (!keystatus[1]&&!(keystatus[0x1c]&&filetypes[curfile]!=2))
 {
if(keystatus[0x1c]||runonce==1)
{
 keystatus[0x1c]=0;
 splc[0]=0;
 if(filetypes[curfile]==2)
 {
  chdir(filenames[curfile]);
  curfile=0;
  viewfile=0;
 }

 if(filetypes[0]==0)
 {
  curfile=0;
  viewfile=0;
 }
 files=0;

   sprintf(wildcard,"*.*");
 if (_dos_findfirst(wildcard,_A_SUBDIR,&fileinfo) != 0);//return;
 else
 do
 if(fileinfo.attrib&_A_SUBDIR)
 {
//  if(filetypes[files]==0||strcmp(filenames[files],fileinfo.name)!=0||filesizes[files]!=fileinfo.size||runonce==1)
  {
   strcpy(filenames[files],fileinfo.name);
   filesizes[files]=fileinfo.size;
   fileuse[files]=0;
   filetypes[files]=2;
  files++;
  }
 }
 while (_dos_findnext(&fileinfo) == 0&&files<MAXWAVES);


   sprintf(wildcard,"*.wav");
 if (_dos_findfirst(wildcard,_A_NORMAL,&fileinfo) != 0);//return;
 else
 do
 {
//  if(filetypes[files]==0||strcmp(filenames[files],fileinfo.name)!=0||filesizes[files]!=fileinfo.size)
  {
   strcpy(filenames[files],fileinfo.name);
   filesizes[files]=fileinfo.size;

   fileuse[files]=3;
   filetypes[files]=1;
   files++;
  }
 }
 while (_dos_findnext(&fileinfo) == 0&&files<MAXWAVES);

 setvmode(0x3);
 displayfile();
 runonce=0;


}

if((keystatus[0x39]||keystatus[0xc8]||keystatus[0xd0])&&splc[0]!=0)
{
splc[0]=0;
clearwave(0);
}
else
{

if (keystatus[0x39])  // Space
{
splc[0]=0;
clearwave(0);
 keystatus[0x39]=0;
 loadfile(0);
 wsay(filenames[curfile],4096L,SND_VOLUME,SND_VOLUME);
}


   if (
   keystatus[0xc8]||keystatus[0xd0]||
   keystatus[0xc9]||keystatus[0xd1]||
   keystatus[0xc7]||keystatus[0xcf]
   )  // updown
   {
      splc[0]=0;
      clearwave(0);


      if(keystatus[0xd0])       curfile++;
      if(keystatus[0xc8])       curfile--;
      if(keystatus[0xd1])       curfile+=24;
      if(keystatus[0xc9])       curfile-=24;
      if(keystatus[0xc7])       curfile=0;
      if(keystatus[0xcf])       curfile=files-1;
       if(curfile>=files-1)curfile=files-1;
       if(curfile<=0)curfile=0;
       while(curfile-viewfile>=25)viewfile++;
       while(viewfile-curfile>0)viewfile--;
      keystatus[0xc8] = 0;
      keystatus[0xd0] = 0;
      keystatus[0xc9] = 0;
      keystatus[0xd1] = 0;
      keystatus[0xc7] = 0;
      keystatus[0xcf] = 0;

      displayfile();
      if(keystatus[0x1d]||keystatus[0x9d])
      {
       loadfile(0);
       wsay(filenames[curfile],4096L,SND_VOLUME,SND_VOLUME);
      }
   }



}

 }
 keystatus[1]=0;

if(keystatus[0x1c])
{
keystatus[0x1c]=0;
loadfile(instnum);
}
keystatus[0x1c]=0;

splc[0]=0;
clearwave(0);

 predisplaywave();
 displaywave(viewinst,instnum);
}

addwave(int wave)
{
 long fil, i, j, dawaversionum;
 char filename[80];
#ifdef SNDCPY
 short snd16;
 short snd16s;
#else
 short *snd16;
 short *snd16s;
#endif
 long offset;
 long size;
 FILE *in;
 char filestring[1024];
 clearwave(wave);
 offset=totsndbytes;
 size=wavheader[curfile].c;


for(i=MAXWAVES-1;i>=wave+1;i--)
memmove(&snd[wavoffs[i]+size-FP_OFF(snd)],&snd[wavoffs[i]-FP_OFF(snd)],wavleng[i]);
for(i=wave+1;i<MAXWAVES;i++)
wavoffs[i]+=size;


totsndbytes+=size;
snd[totsndbytes] = snd[totsndbytes+1] = 128;

   sprintf(filestring,"%s",filenames[curfile]);
in=fopen(filestring,"rb");
fseek(in,44,SEEK_SET);
fread(&snd[wavoffs[wave]-FP_OFF(snd)],1,wavheader[curfile].c,in);
fclose(in);




if(wavheader[curfile].d2==16&&wavheader[curfile].chan==2)
{
 size/=4;
 for(i=0;i<size;i++)
#ifdef SNDCPY
 {
  memcpy(&snd16,&snd[wavoffs[wave]-FP_OFF(snd)+i*4],2);
  memcpy(&snd16s,&snd[wavoffs[wave]-FP_OFF(snd)+i*4+2],2);
  snd[wavoffs[wave]-FP_OFF(snd)+i]=(snd16+snd16s)/512+128;
 }
#else
 {
  snd16=&snd[wavoffs[wave]-FP_OFF(snd)+i*4];
  snd16s=&snd[wavoffs[wave]-FP_OFF(snd)+i*4+2];
  snd[wavoffs[wave]-FP_OFF(snd)+i]=(*snd16+*snd16s)/512+128;
 }
#endif
 for(i=wave+1;i<MAXWAVES;i++)
  memmove(&snd[wavoffs[i]-size-FP_OFF(snd)],&snd[wavoffs[i]-FP_OFF(snd)],wavleng[i]);
 for(i=wave+1;i<MAXWAVES;i++)
  wavoffs[i]-=size;
 totsndbytes-=size;
 snd[totsndbytes] = snd[totsndbytes+1] = 128;
}
else
{










if(wavheader[curfile].d2==16)
{
 size/=2;
 for(i=0;i<size;i++)
//  (unsigned char)(256.0f*(*snd16+32768.0f)/65536.0f);
#ifdef SNDCPY
 {
  memcpy(&snd16,&snd[wavoffs[wave]-FP_OFF(snd)+i*2],2);
  snd[wavoffs[wave]-FP_OFF(snd)+i]=(unsigned char)(snd16/256+128);
 }
#else
 {
  snd16=&snd[wavoffs[wave]-FP_OFF(snd)+i*2];
  snd[wavoffs[wave]-FP_OFF(snd)+i]=*snd16/256+128;
 }
#endif
 for(i=wave+1;i<MAXWAVES;i++)
  memmove(&snd[wavoffs[i]-size-FP_OFF(snd)],&snd[wavoffs[i]-FP_OFF(snd)],wavleng[i]);
 for(i=wave+1;i<MAXWAVES;i++)
  wavoffs[i]-=size;
 totsndbytes-=size;
 snd[totsndbytes] = snd[totsndbytes+1] = 128;
}


if(wavheader[curfile].chan==2)
{
 size/=2;
 for(i=0;i<size;i++)
 snd[wavoffs[wave]-FP_OFF(snd)+i]=
  (snd[wavoffs[wave]-FP_OFF(snd)+i*2+1]+
  snd[wavoffs[wave]-FP_OFF(snd)+i*2])/2;
 for(i=wave+1;i<MAXWAVES;i++)
  memmove(&snd[wavoffs[i]-size-FP_OFF(snd)],&snd[wavoffs[i]-FP_OFF(snd)],wavleng[i]);
 for(i=wave+1;i<MAXWAVES;i++)
  wavoffs[i]-=size;
 totsndbytes-=size;
 snd[totsndbytes] = snd[totsndbytes+1] = 128;
}


}
      wavleng[wave] = size;
      repstart[wave] = 0L;
      repleng[wave] = 0L;
      if(wavheader[curfile].b3==11025)
       finetune[wave]=0;
      else
       finetune[wave] = 748L*(long)(wavheader[curfile].b3-11025)/11025L;


memcpy(instname[wave],filenames[curfile],16);


}


clearwave(int wave)
{
 char *tsnd;
 long fil, i, j, dawaversionum;
 char filename[80];
 long offset;
 long size;
 offset=totsndbytes;
 size=wavleng[wave];
 for(i=wave+1;i<MAXWAVES;i++)
  memmove(&snd[wavoffs[i]-size-FP_OFF(snd)],&snd[wavoffs[i]-FP_OFF(snd)],wavleng[i]);
 for(i=wave+1;i<MAXWAVES;i++)
  wavoffs[i]-=size;
 totsndbytes-=size;
 snd[totsndbytes] = snd[totsndbytes+1] = 128;
 wavleng[wave] = 0L;
 repstart[wave] = 0L;
 repleng[wave] = 0L;
 finetune[wave] = 0L;
 if(wave)
  instname[wave][0]=0;
 else
  sprintf(instname[wave],"reserved space");
}

insertwave()
{
 wavoffs[numwaves]=wavoffs[numwaves-1]+wavleng[numwaves-1];
 wavleng[numwaves] = 0L;
 repstart[numwaves] = 0L;
 repleng[numwaves] = 0L;
 finetune[numwaves] = 0L;
 sprintf(instname[numwaves++],"");
}
#define deletewave() clearwave(--numwaves)

savewaves(char *wavename)
{
 long i,dawaversionum=0;
 FILE *out;
 out=fopen(wavename,"wb");
 fwrite(&dawaversionum,1,4,out);
 fwrite(&numwaves,1,4,out);
 for(i=0;i<numwaves;i++)
 {
  fwrite(instname[i],1,16,out);
  fwrite(&wavleng[i],1,4,out);
  fwrite(&repstart[i],1,4,out);
  fwrite(&repleng[i],1,4,out);
  fwrite(&finetune[i],1,4,out);
 }
 fwrite(snd,1,totsndbytes,out);
 fclose(out);
}
